---
title: 'CSP: sandbox'
slug: Web/HTTP/Headers/Content-Security-Policy/sandbox
tags:
  - CSP
  - Content-Security-Policy
  - Directive
  - HTTP
  - Sandbox
  - Security
---
<div>{{HTTPSidebar}}</div>

<p>The HTTP {{HTTPHeader("Content-Security-Policy")}} (CSP) <code><strong>sandbox</strong></code> directive enables a sandbox for the requested resource similar to the {{HTMLElement("iframe")}} {{htmlattrxref("sandbox", "iframe")}} attribute. It applies restrictions to a page's actions including preventing popups, preventing the execution of plugins and scripts, and enforcing a same-origin policy.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">CSP version</th>
   <td>1.1 / 2</td>
  </tr>
  <tr>
   <th scope="row">Directive type</th>
   <td>{{Glossary("Document directive")}}</td>
  </tr>
  <tr>
   <th colspan="2" scope="row">This directive is not supported in the {{HTMLElement("meta")}} element or by the {{HTTPHeader("Content-Security-policy-Report-Only")}} header field.</th>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Content-Security-Policy: sandbox;
Content-Security-Policy: sandbox &lt;value&gt;;
</pre>

<p>where <code>&lt;value&gt;</code> can optionally be one of the following values:</p>

<dl>
 <dt><code>allow-downloads-without-user-activation</code> {{experimental_inline}}</dt>
 <dd>Allows for downloads to occur without a gesture from the user.</dd>
</dl>

<dl>
 <dt><code>allow-forms</code></dt>
 <dd>Allows the page to submit forms. If this keyword is not used, this operation is not allowed.</dd>
 <dt><code>allow-modals</code></dt>
 <dd>Allows the page to open modal windows.</dd>
 <dt><code>allow-orientation-lock</code></dt>
 <dd>Allows the page to disable the ability to lock the screen orientation.</dd>
 <dt><code>allow-pointer-lock</code></dt>
 <dd>Allows the page to use the <a href="/en-US/docs/WebAPI/Pointer_Lock">Pointer Lock API</a>.</dd>
 <dt><code>allow-popups</code></dt>
 <dd>Allows popups (like from <code>window.open</code>, <code>target="_blank"</code>, <code>showModalDialog</code>). If this keyword is not used, that functionality will silently fail.</dd>
 <dt><code>allow-popups-to-escape-sandbox</code></dt>
 <dd>Allows a sandboxed document to open new windows without forcing the sandboxing flags upon them. This will allow, for example, a third-party advertisement to be safely sandboxed without forcing the same restrictions upon a landing page.</dd>
 <dt><code>allow-presentation</code></dt>
 <dd>Allows embedders to have control over whether an iframe can start a presentation session.</dd>
 <dt><code>allow-same-origin</code></dt>
 <dd>Allows the content to be treated as being from its normal origin. If this keyword is not used, the embedded content is treated as being from a unique origin.</dd>
 <dt><code>allow-scripts</code></dt>
 <dd>Allows the page to run scripts (but not create pop-up windows). If this keyword is not used, this operation is not allowed.</dd>
 <dt><code>allow-storage-access-by-user-activation</code> {{experimental_inline}}</dt>
 <dd>Lets the resource request access to the parent's storage capabilities with the <a href="/en-US/docs/Web/API/Storage_Access_API">Storage Access API</a>.</dd>
 <dt><code>allow-top-navigation</code></dt>
 <dd>Allows the page to navigate (load) content to the top-level browsing context. If this keyword is not used, this operation is not allowed.</dd>
 <dt><code>allow-top-navigation-by-user-activation</code></dt>
 <dd>Lets the resource navigate the top-level browsing context, but only if initiated by a user gesture.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: bash">Content-Security-Policy: sandbox allow-scripts;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{specName("CSP 3.0", "#directive-sandbox", "sandbox")}}</td>
   <td>{{Spec2('CSP 3.0')}}</td>
   <td>No changes.</td>
  </tr>
  <tr>
   <td>{{specName("CSP 1.1", "#directive-sandbox", "sandbox")}}</td>
   <td>{{Spec2('CSP 1.1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.csp.Content-Security-Policy.sandbox")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Content-Security-Policy")}}</li>
 <li>{{htmlattrxref("sandbox", "iframe")}} attribute on {{HTMLElement("iframe")}} elements</li>
</ul>
